geos::geom::util::GeometryTransformer Class Reference

A framework for processes which transform an input Geometry into an output Geometry, possibly changing its structure and type(s). More...

`#include <GeometryTransformer.h>`

Inheritance diagram for geos::geom::util::GeometryTransformer:

## Public Member Functions

std::unique_ptr< Geometry > | transform (const Geometry *nInputGeom)
void | setSkipTransformedInvalidInteriorRings (bool b)

## Protected Member Functions

virtual CoordinateSequence::Ptr | transformCoordinates (const CoordinateSequence *coords, const Geometry *parent)
virtual Geometry::Ptr | transformPoint (const Point *geom, const Geometry *parent)
virtual Geometry::Ptr | transformMultiPoint (const MultiPoint *geom, const Geometry *parent)
virtual Geometry::Ptr | transformLinearRing (const LinearRing *geom, const Geometry *parent)
virtual Geometry::Ptr | transformLineString (const LineString *geom, const Geometry *parent)
virtual Geometry::Ptr | transformMultiLineString (const MultiLineString *geom, const Geometry *parent)
virtual Geometry::Ptr | transformPolygon (const Polygon *geom, const Geometry *parent)
virtual Geometry::Ptr | transformMultiPolygon (const MultiPolygon *geom, const Geometry *parent)
virtual Geometry::Ptr | transformGeometryCollection (const GeometryCollection *geom, const Geometry *parent)

## Protected Attributes

const GeometryFactory * | factory

## Detailed Description

A framework for processes which transform an input Geometry into an output Geometry, possibly changing its structure and type(s).

This class is a framework for implementing subclasses which perform transformations on various different Geometry subclasses. It provides an easy way of applying specific transformations to given geometry types, while allowing unhandled types to be simply copied. Also, the framework ensures that if subcomponents change type the parent geometries types change appropriately to maintain valid structure. Subclasses will override whichever transformX methods they need to to handle particular Geometry types.

A typically usage would be a transformation that may transform Polygons into Polygons, LineStrings or Points. This class would likely need to override the GeometryTransformer::transformMultiPolygon(const MultiPolygon* geom, const Geometry* parent) method to ensure that if input Polygons change type the result is a GeometryCollection, not a MultiPolygon

The default behaviour of this class is to simply recursively transform each Geometry component into an identical object by copying.

Note that all transformX methods may return null, to avoid creating empty geometry objects. This will be handled correctly by the transformer. The GeometryTransformer::transform(const Geometry* nInputGeom) method itself will always return a geometry object.

See also
  GeometryEditor

Possible extensions: getParent() method to return immediate parent e.g. of LinearRings in Polygons

The documentation for this class was generated from the following file:

- GeometryTransformer.h